from nanoxmap import *

def setConstraints(project):
    # Port mapping

    # Clocks
    project.addPad('clk_25m_i',    {'location': 'IO_B12D09P', 'type': 'LVCMOS_2.5V_4mA', 'differential': False})
    project.createClock('getPort(clk_25m_i)','clk_25m_i', 40000)
    project.developCKGs()

    # nanoFIP wishbone i/f
    project.addPad('ack_i',        {'location': 'IO_B8D04P',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('adr_o[0]',     {'location': 'IO_B6D04P',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('adr_o[1]',     {'location': 'IO_B6D04N',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('adr_o[2]',     {'location': 'IO_B6D07P',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('adr_o[3]',     {'location': 'IO_B6D07N',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('adr_o[4]',     {'location': 'IO_B7D15P',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('adr_o[5]',     {'location': 'IO_B7D15N',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('adr_o[6]',     {'location': 'IO_B8D14P',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('adr_o[7]',     {'location': 'IO_B8D14N',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('adr_o[8]',     {'location': 'IO_B8D03P',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('adr_o[9]',     {'location': 'IO_B8D03N',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('cyc_o',        {'location': 'IO_B8D13P',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('dat_i[0]',     {'location': 'IO_B9D12P',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('dat_i[1]',     {'location': 'IO_B9D12N',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('dat_i[2]',     {'location': 'IO_B8D01P',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('dat_i[3]',     {'location': 'IO_B8D01N',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('dat_i[4]',     {'location': 'IO_B8D02P',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('dat_i[5]',     {'location': 'IO_B8D02N',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('dat_i[6]',     {'location': 'IO_B9D13P',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('dat_i[7]',     {'location': 'IO_B9D13N',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('dat_o[0]',     {'location': 'IO_B9D01P',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('dat_o[1]',     {'location': 'IO_B9D01N',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('dat_o[2]',     {'location': 'IO_B9D15N',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('dat_o[3]',     {'location': 'IO_B9D15P',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('dat_o[4]',     {'location': 'IO_B9D04N',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('dat_o[5]',     {'location': 'IO_B9D04P',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('dat_o[6]',     {'location': 'IO_B8D07N',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('dat_o[7]',     {'location': 'IO_B8D07P',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('nostat_o',     {'location': 'IO_B9D02P',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('p3_lgth_o[0]', {'location': 'IO_B8D10N',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('p3_lgth_o[1]', {'location': 'IO_B8D13N',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('p3_lgth_o[2]', {'location': 'IO_B8D04N',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('rst_o',        {'location': 'IO_B9D02N',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('rstin_o',      {'location': 'IO_B9D05P',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('wclk_o',       {'location': 'IO_B7D02N',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('stb_o',        {'location': 'IO_B7D03N',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('we_o',         {'location': 'IO_B8D10P',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('var1_acc_o',   {'location': 'IO_B6D09P',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('var1_rdy_i',   {'location': 'IO_B6D09N',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('var2_acc_o',   {'location': 'IO_B6D10P',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('var2_rdy_i',   {'location': 'IO_B6D10N',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('var3_acc_o',   {'location': 'IO_B6D15P',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})
    project.addPad('var3_rdy_i',   {'location': 'IO_B6D15N',  'type': 'LVCMOS_3.3V_4mA', 'differential': False})

    # I2C - connected to TP1, see pin notes.txt
    project.addPad('diag_scl_b',   {'location': 'IO_B0D06P',  'type': 'LVCMOS_3.3V_16mA', 'differential': False})
    project.addPad('diag_sda_b',   {'location': 'IO_B0D07P',  'type': 'LVCMOS_3.3V_16mA', 'differential': False})
    project.addPad('uart_tx',   {'location': 'IO_B0D05P',  'type': 'LVCMOS_3.3V_8mA', 'differential': False})
    project.addPad('uart_rx',   {'location': 'IO_B0D09P',  'type': 'LVCMOS_3.3V_8mA', 'differential': False})
    project.addPad('dbg[0]',   {'location': 'IO_B0D01N',  'type': 'LVCMOS_3.3V_16mA', 'differential': False})
    project.addPad('dbg[1]',   {'location': 'IO_B0D08P',  'type': 'LVCMOS_3.3V_16mA', 'differential': False})
    project.addPad('dbg[2]',   {'location': 'IO_B0D10N',  'type': 'LVCMOS_3.3V_16mA', 'differential': False})
    project.addPad('dbg[3]',   {'location': 'IO_B0D02N',  'type': 'LVCMOS_3.3V_16mA', 'differential': False})
    project.addPad('dbg[4]',   {'location': 'IO_B0D04N',  'type': 'LVCMOS_3.3V_16mA', 'differential': False})

    # Buttons
    project.addPad('button_i',     {'location': 'IO_B10D12P', 'type': 'LVCMOS_1.8V_4mA', 'differential': False})


    # LEDs
    project.addPad('leds_o[0]',    {'location': 'IO_B0D01P',  'type': 'LVCMOS_3.3V_2mA', 'differential': False})
    project.addPad('leds_o[1]',    {'location': 'IO_B0D03N',  'type': 'LVCMOS_3.3V_2mA', 'differential': False})
    project.addPad('leds_o[2]',    {'location': 'IO_B0D03P',  'type': 'LVCMOS_3.3V_2mA', 'differential': False})
    project.addPad('leds_o[5]',    {'location': 'IO_B1D05N',  'type': 'LVCMOS_3.3V_2mA', 'differential': False})
    project.addPad('leds_o[4]',    {'location': 'IO_B1D05P',  'type': 'LVCMOS_3.3V_2mA', 'differential': False})
    project.addPad('leds_o[3]',    {'location': 'IO_B1D06N',  'type': 'LVCMOS_3.3V_2mA', 'differential': False})

    # timing constraints

    # project.setInputDelay('getClock(clk_25m_i)',  'rise', 10000, 15000, 'getPort(dat_i[0])')
    # project.setInputDelay('getClock(clk_25m_i)',  'rise', 10000, 15000, 'getPort(dat_i[1])')
    # project.setInputDelay('getClock(clk_25m_i)',  'rise', 10000, 15000, 'getPort(dat_i[2])')
    # project.setInputDelay('getClock(clk_25m_i)',  'rise', 10000, 15000, 'getPort(dat_i[3])')
    # project.setInputDelay('getClock(clk_25m_i)',  'rise', 10000, 15000, 'getPort(dat_i[4])')
    # project.setInputDelay('getClock(clk_25m_i)',  'rise', 10000, 15000, 'getPort(dat_i[5])')
    # project.setInputDelay('getClock(clk_25m_i)',  'rise', 10000, 15000, 'getPort(dat_i[6])')
    # project.setInputDelay('getClock(clk_25m_i)',  'rise', 10000, 15000, 'getPort(dat_i[7])')
    
    # project.setInputDelay('getClock(clk_25m_i)',  'rise', 10000, 15000, 'getPort(ack_i)')
    # project.setInputDelay('getClock(clk_25m_i)',  'rise', 10000, 15000, 'getPort(var1_rdy_i)')
    # project.setInputDelay('getClock(clk_25m_i)',  'rise', 10000, 15000, 'getPort(var2_rdy_i)')
    # project.setInputDelay('getClock(clk_25m_i)',  'rise', 10000, 15000, 'getPort(var3_rdy_i)')
    # project.setOutputDelay('getClock(clk_25m_i)', 'rise', 10000, 15000, 'getPort(dat_o[0])')
    # project.setOutputDelay('getClock(clk_25m_i)', 'rise', 10000, 15000, 'getPort(dat_o[1])')
    # project.setOutputDelay('getClock(clk_25m_i)', 'rise', 10000, 15000, 'getPort(dat_o[2])')
    # project.setOutputDelay('getClock(clk_25m_i)', 'rise', 10000, 15000, 'getPort(dat_o[3])')
    # project.setOutputDelay('getClock(clk_25m_i)', 'rise', 10000, 15000, 'getPort(dat_o[4])')
    # project.setOutputDelay('getClock(clk_25m_i)', 'rise', 10000, 15000, 'getPort(dat_o[5])')
    # project.setOutputDelay('getClock(clk_25m_i)', 'rise', 10000, 15000, 'getPort(dat_o[6])')
    # project.setOutputDelay('getClock(clk_25m_i)', 'rise', 10000, 15000, 'getPort(dat_o[7])')
    # project.setOutputDelay('getClock(clk_25m_i)', 'rise', 10000, 15000, 'getPort(adr_o[0])')
    # project.setOutputDelay('getClock(clk_25m_i)', 'rise', 10000, 15000, 'getPort(adr_o[1])')
    # project.setOutputDelay('getClock(clk_25m_i)', 'rise', 10000, 15000, 'getPort(adr_o[2])')
    # project.setOutputDelay('getClock(clk_25m_i)', 'rise', 10000, 15000, 'getPort(adr_o[3])')
    # project.setOutputDelay('getClock(clk_25m_i)', 'rise', 10000, 15000, 'getPort(adr_o[4])')
    # project.setOutputDelay('getClock(clk_25m_i)', 'rise', 10000, 15000, 'getPort(adr_o[5])')
    # project.setOutputDelay('getClock(clk_25m_i)', 'rise', 10000, 15000, 'getPort(adr_o[6])')
    # project.setOutputDelay('getClock(clk_25m_i)', 'rise', 10000, 15000, 'getPort(adr_o[7])')
    # project.setOutputDelay('getClock(clk_25m_i)', 'rise', 10000, 15000, 'getPort(stb_o)')
    # project.setOutputDelay('getClock(clk_25m_i)', 'rise', 10000, 15000, 'getPort(we_o)')
    # project.setOutputDelay('getClock(clk_25m_i)', 'rise', 10000, 15000, 'getPort(cyc_o)')
    # project.setOutputDelay('getClock(clk_25m_i)', 'rise', 10000, 15000, 'getPort(nostat_o)')
    # project.setOutputDelay('getClock(clk_25m_i)', 'rise', 10000, 15000, 'getPort(p3_lgth_o[0])')
    # project.setOutputDelay('getClock(clk_25m_i)', 'rise', 10000, 15000, 'getPort(p3_lgth_o[1])')
    # project.setOutputDelay('getClock(clk_25m_i)', 'rise', 10000, 15000, 'getPort(p3_lgth_o[2])')
    # project.setOutputDelay('getClock(clk_25m_i)', 'rise', 10000, 15000, 'getPort(rst_o)')
    # project.setOutputDelay('getClock(clk_25m_i)', 'rise', 10000, 15000, 'getPort(rstin_o)')
    # project.setOutputDelay('getClock(clk_25m_i)', 'rise', 10000, 15000, 'getPort(var1_acc_o)')
    # project.setOutputDelay('getClock(clk_25m_i)', 'rise', 10000, 15000, 'getPort(var2_acc_o)')
    # project.setOutputDelay('getClock(clk_25m_i)', 'rise', 10000, 15000, 'getPort(var3_acc_o)')
