import serial
import time
from os import system
from tabulate import tabulate

def getWord(data, i):
    return(256*data[i+1]+data[i])

def getADC(data, i):
    return(4.096*getWord(data, i)/2**15)

def getLM73(data, i):
    return((getWord(data, i) >> 5)*0.25)

def monPrint(data):
    # for i in range(34):
    #     print('{:x}'.format(data[i]), end=' ')
    system('clear')
    myheaders = ['Rail', 'Voltage [V]', 'Current [mA]']
    mytable = [['1V2', 0, 0],
               ['1V8', 0, 0],
               ['2V5', 0, 0],
               ['3V3', 0, 0],
               ['Vfmc', 0, 0],
               ['Vhmc', 0, 0],
               ['Vaux', 0, 0]]

    mytable[0][1] = getADC(data, 0)
    mytable[1][1] = getADC(data, 2)
    mytable[2][1] = getADC(data, 4)
    mytable[3][1] = getADC(data, 6)*1.2
    mytable[4][1] = getADC(data, 8)*1.2
    mytable[5][1] = getADC(data, 10)*1.2
    mytable[6][1] = getADC(data, 12)

    mytable[0][2] = getADC(data, 14)*1000
    mytable[1][2] = getADC(data, 16)*500
    mytable[2][2] = getADC(data, 18)*500
    mytable[3][2] = getADC(data, 20)*500
    mytable[4][2] = getADC(data, 22)*500
    mytable[5][2] = getADC(data, 24)*500
    mytable[6][2] = getADC(data, 26)*1000

    print('Temperature:  {:f}'.format(getLM73(data, 28)))
    print()
    print(tabulate(mytable, myheaders), flush=True)

def findAlignment(data):
    for i in range(34):
        if ((data[31] == 0x00) and
            (data[32] == 0xBE) and
            (data[33] == 0xC0)):
            break
        else:
            data = data[1:] + data[:1]
    return(data)


ser = serial.Serial('/dev/ttyUSB0')
while True:
    data = bytearray(ser.read(34))
    data = findAlignment(data)
    monPrint(data)
    time.sleep(1)
